------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Fonts;
with Qt4.Icons;
with Qt4.Key_Sequences;
with Qt4.Objects;
with Qt4.Strings;
with Qt4.Variants;
limited with Qt4.Widgets;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Actions is

   type Action_Action_Event is
    (Trigger,
     Hover);
   pragma Convention (C, Action_Action_Event);

   type Action_Menu_Role is
    (No_Role,
     Text_Heuristic_Role,
     Application_Specific_Role,
     About_Qt_Role,
     About_Role,
     Preferences_Role,
     Quit_Role);
   pragma Convention (C, Action_Menu_Role);

   type Q_Action is limited interface
     and Qt4.Objects.Q_Object;

   type Q_Action_Access is
     access all Q_Action'Class;
   for Q_Action_Access'Storage_Size use 0;

   type Q_Action_Pointer is tagged;

   procedure Activate
    (Self : not null access Q_Action'Class;
     Event : Qt4.Actions.Action_Action_Event);

   function Auto_Repeat
    (Self : not null access constant Q_Action'Class)
       return Standard.Boolean;

   function Data
    (Self : not null access constant Q_Action'Class)
       return Qt4.Variants.Q_Variant;

   function Font
    (Self : not null access constant Q_Action'Class)
       return Qt4.Fonts.Q_Font;

   function Icon
    (Self : not null access constant Q_Action'Class)
       return Qt4.Icons.Q_Icon;

   function Icon_Text
    (Self : not null access constant Q_Action'Class)
       return Qt4.Strings.Q_String;

   function Is_Checkable
    (Self : not null access constant Q_Action'Class)
       return Standard.Boolean;

   function Is_Checked
    (Self : not null access constant Q_Action'Class)
       return Standard.Boolean;

   function Is_Enabled
    (Self : not null access constant Q_Action'Class)
       return Standard.Boolean;

   function Is_Separator
    (Self : not null access constant Q_Action'Class)
       return Standard.Boolean;

   function Is_Visible
    (Self : not null access constant Q_Action'Class)
       return Standard.Boolean;

   function Menu_Role
    (Self : not null access constant Q_Action'Class)
       return Qt4.Actions.Action_Menu_Role;

   function Parent_Widget
    (Self : not null access constant Q_Action'Class)
       return not null access Qt4.Widgets.Q_Widget'Class;

   procedure Set_Auto_Repeat
    (Self : not null access Q_Action'Class;
     Enable : Standard.Boolean);

   procedure Set_Checkable
    (Self : not null access Q_Action'Class;
     Checkable : Standard.Boolean);

   procedure Set_Data
    (Self : not null access Q_Action'Class;
     Data : Qt4.Variants.Q_Variant);

   procedure Set_Font
    (Self : not null access Q_Action'Class;
     Font : Qt4.Fonts.Q_Font);

   procedure Set_Icon
    (Self : not null access Q_Action'Class;
     Icon : Qt4.Icons.Q_Icon);

   procedure Set_Icon_Text
    (Self : not null access Q_Action'Class;
     Text : Qt4.Strings.Q_String);

   procedure Set_Menu_Role
    (Self : not null access Q_Action'Class;
     Menu_Role : Qt4.Actions.Action_Menu_Role);

   procedure Set_Separator
    (Self : not null access Q_Action'Class;
     B : Standard.Boolean);

   procedure Set_Shortcut
    (Self : not null access Q_Action'Class;
     Shortcut : Qt4.Key_Sequences.Q_Key_Sequence);

   procedure Set_Status_Tip
    (Self : not null access Q_Action'Class;
     Status_Tip : Qt4.Strings.Q_String);

   procedure Set_Text
    (Self : not null access Q_Action'Class;
     Text : Qt4.Strings.Q_String);

   procedure Set_Tool_Tip
    (Self : not null access Q_Action'Class;
     Tip : Qt4.Strings.Q_String);

   procedure Set_Whats_This
    (Self : not null access Q_Action'Class;
     What : Qt4.Strings.Q_String);

   function Shortcut
    (Self : not null access Q_Action'Class)
       return Qt4.Key_Sequences.Q_Key_Sequence;

   function Status_Tip
    (Self : not null access constant Q_Action'Class)
       return Qt4.Strings.Q_String;

   function Text
    (Self : not null access constant Q_Action'Class)
       return Qt4.Strings.Q_String;

   function Tool_Tip
    (Self : not null access constant Q_Action'Class)
       return Qt4.Strings.Q_String;

   function Whats_This
    (Self : not null access constant Q_Action'Class)
       return Qt4.Strings.Q_String;

   procedure Hover
    (Self : not null access Q_Action'Class);

   procedure Set_Checked
    (Self : not null access Q_Action'Class;
     B : Standard.Boolean);

   procedure Set_Disabled
    (Self : not null access Q_Action'Class;
     B : Standard.Boolean);

   procedure Set_Enabled
    (Self : not null access Q_Action'Class;
     B : Standard.Boolean);

   procedure Set_Visible
    (Self : not null access Q_Action'Class;
     B : Standard.Boolean);

   procedure Toggle
    (Self : not null access Q_Action'Class);

   procedure Trigger
    (Self : not null access Q_Action'Class);

   package Q_Action_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Action, Q_Action_Access);

   type Q_Action_Pointer is
     new Q_Action_Pointers.Q_Pointer with null record;

end Qt4.Actions;
